
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');
const TenantAccess = require('./tenantAccess');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Control_frameworksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const control_frameworks = await db.control_frameworks.create(
            {
                id: data.id || undefined,
        
        framework_name: data.framework_name
        ||
        null
            ,
            
        version: data.version
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        active_flag: data.active_flag
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await control_frameworks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return control_frameworks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const control_frameworksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                framework_name: item.framework_name
            ||
            null
            ,
            
                version: item.version
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                active_flag: item.active_flag
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const control_frameworks = await db.control_frameworks.bulkCreate(control_frameworksData, { transaction });

        // For each item created, replace relation files
        

        return control_frameworks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const control_frameworks = await TenantAccess.findByPkOrThrow(db.control_frameworks, id, options);


        

        const updatePayload = {};
        
        if (data.framework_name !== undefined) updatePayload.framework_name = data.framework_name;
        
        
        if (data.version !== undefined) updatePayload.version = data.version;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.active_flag !== undefined) updatePayload.active_flag = data.active_flag;
        
        
        updatePayload.updatedById = currentUser.id;

        await control_frameworks.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await control_frameworks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return control_frameworks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const control_frameworks = await TenantAccess.findAllByIds(db.control_frameworks, ids, options);

        await db.sequelize.transaction(async (transaction) => {
            for (const record of control_frameworks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of control_frameworks) {
                await record.destroy({transaction});
            }
        });


        return control_frameworks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const control_frameworks = await TenantAccess.findByPkOrThrow(db.control_frameworks, id, options);

        await control_frameworks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await control_frameworks.destroy({
            transaction
        });

        return control_frameworks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const control_frameworks = await TenantAccess.findOne(db.control_frameworks, where, options);

        if (!control_frameworks) {
            return control_frameworks;
        }

        const output = control_frameworks.get({plain: true});

        
        
        
        
        
        
        
        
        output.control_requirements_framework = await control_frameworks.getControl_requirements_framework({
            transaction
        });
        
        
        
        
        
        
        output.proof_packets_framework = await control_frameworks.getProof_packets_framework({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.organizations = await control_frameworks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.framework_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'control_frameworks',
                        'framework_name',
                        filter.framework_name,
                    ),
                };
            }
            
            if (filter.version) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'control_frameworks',
                        'version',
                        filter.version,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'control_frameworks',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active_flag) {
                where = {
                    ...where,
                active_flag: filter.active_flag,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.control_frameworks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'control_frameworks',
                        'framework_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.control_frameworks.findAll({
            attributes: [ 'id', 'framework_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['framework_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.framework_name,
        }));
    }

    
};

